<?PHP

class SQL
{
  var $conidx;
  var $result;
  var $num_rows;

  function SQL($dbuser, $dbpwd, $dbhost, $dbport, $dbname)
  {
    if(!empty($dbname))
      $connectstring=$connectstring."dbname=".$dbname." ";
    if(!empty($dbhost))
      $connectstring=$connectstring."host=".$dbhost." ";
    if(!empty($dbport))
      $connectstring=$connectstring."port=".$dbport." ";
    if(!empty($dbuser))
      $connectstring=$connectstring."user=".$dbuser." ";
    if(!empty($dbpwd))
      $connectstring=$connectstring."password=".$dbpwd;
    if(!empty($connectstring))
      $this->conidx = pg_pconnect($connectstring);
    else
      $this->conidx = -1;
    return($this->conidx);
  }

  function SQLquery($SQLcommand)
  {
    if(empty($SQLcommand))
      return(-1);
    $this->result=pg_exec($this->conidx, $SQLcommand);
    if($this->result <= 0)
    {
      echo($SQLcommand);
      return(-1);
    }
    else
      return(1);
  }

  function SQLnum_rows()
  {
    $this->num_rows = pg_numrows($this->result);
    return($this->num_rows);
  }

  function SQLfetch_array($row)
  {
    return(pg_fetch_array($this->result,$row));
  }
}

class BSQL
{
  var $conidx;
  var $result;
  var $num_rows;
  var $dbname;

  function BSQL($dbuser, $dbpwd, $dbhost, $dbport, $dbname)
  {
    if(empty($dbname))
      return(-2);
    else
      $this->dbname = $dbname;
    if(empty($dbhost))
      return(-3);
    if(empty($dbuser))
      return(-4);
    if(empty($dbpwd))
      return(-5);
    if(empty($dbport))
      $this->conidx = mysql_connect($dbhost, $dbuser, $dbpwd);
    else
      $this->conidx = mysql_connect($dbhost.":".$dbport, $dbuser, $dbpwd);
    if($this->conidx == FALSE)
      $this->conidx = -1;

  }

  function SQLquery($SQLcommand)
  {
    if(empty($SQLcommand))
      return(-1);
    $this->result=mysql_db_query($this->dbname, $SQLcommand, $this->conidx);
    if($this->result == FALSE)
    {
      echo($SQLcommand."<BR>\n");
      echo(mysql_errno().": ".mysql_error()."<BR>\n");
      return(-1);
    }
    else
      return(1);
  }

  function SQLnum_rows()
  {
    $this->num_rows = mysql_num_rows($this->result);
    return($this->num_rows);
  }

  function SQLfetch_array()
  {
    return(mysql_fetch_array($this->result));
  }
}

class Security
{
  var $level; // 1 = Admin, 2 = Own data, 3 = Project data
  var $user;

  function Security($user, $level)
  {
    $this->user=$user;
    $this->level=$level;
  }

  function check_u_nr($u_nr)
  {
    switch($this->level)
    {
      case 1:
      {
        if($this->user->god == 1)
          return 1;
        else
          return -1;
      }
      case 2:
      {
        if($this->user->god == 1 OR $this->user->u_nr == $u_nr)
          return 1;
        else
          return -1;
      }
      case 3:
      {
        return 1;
      }
    }
  }

  function check_i_id($i_id)
  {
    switch($this->level)
    {
      case 1:
      {
        if($this->user->god == 1)
          return 1;
        else
          return -1;
      }
      case 2:
      {
        if($this->user->god == 1 OR $this->user->i_id == $i_id)
          return 1;
        else
          return -1;
      }
      case 3:
      {
        return 1;
      }
    }
  }

  function check_a_id($a_id)
  {
    switch($this->level)
    {
      case 1:
      {
        if($this->user->god == 1)
          return 1;
        else
          return -1;
      }
      case 2:
      {
        if($this->user->god == 1)
          return 1;
        $this->user->load_addresses();
        for($i=0; $i < $this->user->a_count; $i++)
        {
          if($this->user->a_id[$i] == $a_id)
            return 1;
        }
        return -1;
      }
      case 3:
      {
        return 1;
      }
    }
  }

  function check_ac_id($ac_id)
  {
    switch($this->level)
    {
      case 1:
      {
        if($this->user->god == 1)
          return 1;
        else
          return -1;
      }
      case 2:
      {
        if($this->user->god == 1)
          return 1;
        $this->user->load_contacts();
        for($i=0; $i < $this->user->c_count; $i++)
        {
          if($this->user->c_id[$i] == $ac_id)
            return 1;
        }
        return -1;
      } 
      case 3:
      {
        return 1;
      }
    }
  }
  
  function check_admin($i_id)
  {
    if($i_id != $this->user->i_id)
      return -1;
    if($this->user->god == 1)
      return 1;
    else
      return -1;
  }
}
class Identity
{
  var $SQL;
  var $cfg;
  var $i_nr = -1;
  var $i_id = -1;
  var $i_forname = "";
  var $i_surename ="";
  var $name = "";
  var $i_comment ="";
  var $i_pic_id = -1;
  var $a_count=-1;
  var $a_id;
  var $a_address;
  var $a_postcode;
  var $a_city;
  var $a_county;
  var $a_country;
  var $c_count=-1;
  var $c_a_id;
  var $c_id;
  var $c_acr;
  var $c_name;
  var $c_data;

  function Identity($SQL, $cfg, $i_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    else
      $this->SQL = $SQL;
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    else
      $this->cfg = $cfg;
    if(empty($i_id))
    {
      echo("ERROR: no identity given!\n");
      return(-1);
    }
    else
      $this->i_id = $i_id;
    if($this->i_id >= 0)
    {
      $SQL->SQLquery("SELECT i_nr, i_forename, i_surname, i_comment, i_pic_id FROM identity WHERE i_id='$this->i_id' AND i_status='V'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        $this->i_nr = $row[i_nr];
        $this->name = $row[i_forename]." ".$row[i_surname];
        $this->i_forename = $row[i_forename];
        $this->i_surname = $row[i_surname];
        $this->i_comment = $row[i_comment];
        $this->i_pic_id = $row[i_pic_id];
        return(1);
      }
      else
        echo("ERROR: can't find identity in SQLdb!\n");
      return(-1);
    }
  }

  function load_addresses()
  {
    $this->SQL->SQLquery("SELECT a.a_id, a.a_address, a.a_city, a.a_postcode, a.a_county, ac.aco_name FROM identity_address ia, address a, address_countries ac WHERE a.a_countrycode=ac.aco_id AND a.a_status='V' AND a.a_id = ia.a_id AND ia.i_id='$this->i_id' AND ia.ia_status='V'");
    $num=$this->SQL->SQLnum_rows();
    $this->a_count=$num;
    if($num != 0)
    {
      for($i=0; $i < $num; $i++)
      {
        $row=$this->SQL->SQLfetch_array($i);
        $this->a_id[$i] = $row[a_id];
        $this->a_address[$i] = $row[a_address];
        $this->a_postcode[$i] = $row[a_postcode];
        $this->a_city[$i] = $row[a_city];
        $this->a_county[$i] = $row[a_county];
        $this->a_country[$i] = $row[aco_name];
      }
      return(1);
    }
    return(-1);
  }

  function load_contact($ac_id)
  {
    $this->SQL->SQLquery("SELECT ac.ac_data, act.act_name, ac.a_id FROM address_contact ac, address_ctype act WHERE ac.ac_id='".$ac_id."' AND ac.act_id=act.act_id ");
    if($this->SQL->SQLnum_rows() != 0)
    {
      $row=$this->SQL->SQLfetch_array(0);
      $data[0]=$row[act_name];
      $data[1]=$row[ac_data];
      $data[2]=$row[a_id];
    }
    return($data);
  }

  function get_contact($act_acronym)
  {
    $this->SQL->SQLquery("SELECT ac.ac_data FROM address_contact ac, address_ctype act, identity_address ia WHERE ia.i_id='".$this->i_id."' AND ia.a_id=ac.a_id AND ac.act_id=act.act_id AND act_acronym='".$act_acronym."' AND ac.ac_status='V' AND ia.ia_status='V'");
    if($this->SQL->SQLnum_rows() != 0)
    {
      $row=$this->SQL->SQLfetch_array(0);
      $data=$row[ac_data];
    }
    return($data);
  }

  function load_contacts()
  {
    $this->SQL->SQLquery("SELECT act.act_acronym, act.act_name, ac.ac_id, ac.ac_data, ia.a_id FROM identity_address ia, address_contact ac, address_ctype act WHERE ia.i_id=".$this->i_id."  AND ia.a_id=ac.a_id AND ac.act_id=act.act_id AND ac.ac_status='V' AND ia.ia_status='V'");
    $num=$this->SQL->SQLnum_rows();
    $this->c_count=$num;
    if($num != 0)
    {
      for($i=0; $i < $num; $i++)
      {
        $row=$this->SQL->SQLfetch_array($i);
        $this->c_a_id[$i]=$row[a_id];
        $this->c_id[$i]=$row[ac_id];
        $this->c_acr[$i]=$row[act_acronym];
        $this->c_name[$i]=$row[act_name];
        $this->c_data[$i]=$row[ac_data];
      }
      return(1);
    }
    return(-1);
  }
}

class Company
{ 
  var $SQL;
  var $cfg;
  var $c_id;
  var $c_nr;
  var $c_name;
  var $c_url;
  var $c_desc;
  var $cb_count;
  var $cb_id;
  var $cb_nr;
  var $cb_name;
  var $cb_acronym;
  var $cb_url;
  var $cb_a_id;
  var $cb_contact_count;
  var $cb_contact_i_id;
  var $cb_contact_cc_nr;
  var $cb_contact_i_name;
  var $cb_contact_cct_name;
  var $cb_address_count;
  var $cb_address_id;
  var $cb_address_address;
  var $cb_address_postcode;
  var $cb_address_city;
  var $cb_address_county;
  var $cb_address_country;
  var $cb_address_countrycode;
  var $cb_address_ac_count;
  var $cb_address_ac_id;

  function Company($SQL, $cfg, $c_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    else
      $this->SQL = $SQL;
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    else
      $this->cfg = $cfg;
    if(empty($c_id))
    {
      echo("ERROR: no company id given!\n");
      return(-1);
    }
    else
      $this->c_id = $c_id;
    if($this->c_id >= 0)
    {
      $SQL->SQLquery("SELECT c_nr, c_name, c_acronym, c_url, c_desc FROM company WHERE c_id='$this->c_id' AND c_status='V'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        $this->c_nr = $row[c_nr];
        $this->c_name = $row[c_name];
        $this->c_acronym = $row[c_acronym];
        $this->c_url = $row[c_url];
        $this->c_desc = $row[c_desc];
      }
      $SQL->SQLquery("SELECT cb.cb_id, cb.cb_nr, cb.cb_name, cb.cb_acronym, cb.cb_url, cb.cb_desc, cb.cb_comment, cb.a_id FROM company_branch cb WHERE cb.c_id='$this->c_id' AND cb.cb_status='V'");
      for($i=0;$i<$SQL->SQLnum_rows();$i++)
      {
        $row=$SQL->SQLfetch_array($i);
        $this->cb_id[$i] = $row[cb_id];
        $this->cb_nr[$i] = $row[cb_nr];
        $this->cb_name[$i] = $row[cb_name];
        $this->cb_acronym[$i] = $row[cb_acronym];
        $this->cb_desc[$i] = $row[cb_desc];
        $this->cb_comment[$i] = $row[cb_comment];
        $this->cb_url[$i] = $row[cb_url];
        $this->cb_a_id[$i] = $row[a_id];
      }
      $this->cb_count = $i;
      return(1);
    }
    else
      return(-1);
  }

  function get_ibranchnr($cb_id)
  {
    for($i=0; $i < $this->cb_count; $i++)
    {
      if($cb_id == $this->cb_id[$i])
        return($i);
    }
    return(-1);
  }

  function load_address()
  {
    for($i=0; $i < $this->cb_count; $i++)
    {
      $this->SQL->SQLquery("SELECT a.a_id, a.a_address, a.a_postcode, a.a_city, a.a_county, a.a_countrycode, aco.aco_name FROM address a, address_countries aco WHERE a.a_id=".$this->cb_a_id[$i]." AND a.a_countrycode=aco.aco_id AND a.a_status='V'");
      $num=$this->SQL->SQLnum_rows();
      $this->cb_address_count[$i]=$num;
      if($num != 0)
      {
        for($j=0; $j < $num; $j++)
        {
          $row=$this->SQL->SQLfetch_array($j);
          $this->cb_address_id[$i][$j]=$row[a_id];
          $this->cb_address_address[$i][$j]=$row[a_address];
          $this->cb_address_postcode[$i][$j]=$row[a_postcode];
          $this->cb_address_city[$i][$j]=$row[a_city];
          $this->cb_address_county[$i][$j]=$row[a_county];
          $this->cb_address_country[$i][$j]=$row[aco_name];
          $this->cb_address_countrycode[$i][$j]=$row[a_countrycode];
        }
      }
      if($num != 0)
      {
        for($j=0; $j < $num; $j++)
        {
          $this->SQL->SQLquery("SELECT ac.ac_id FROM address_contact ac WHERE ac.a_id=".$this->cb_address_id[$i][$j]." AND ac.ac_status='V'");
          $num2=$this->SQL->SQLnum_rows();
          $this->cb_address_ac_count[$i][$j]=$num2;
          if($num2 != 0)
          {
            for($k=0; $k < $num2; $k++)
            {
              $row=$this->SQL->SQLfetch_array($k);
              $this->cb_address_ac_id[$i][$j][$k]=$row[ac_id];
            }
          }
        }
      }
    }
    return(1);
  }
  
  function get_contact($i_id)
  {
    for($i=0; $i < $this->cb_count; $i++)
      for($j=0; $j < $this->cb_contact_count[$i]; $j++)
        if($this->cb_contact_i_id[$i][$j]==$i_id)
        {
          $data[0]=$i_id;
          $data[1]=$this->cb_contact_i_name[$i][$j];
          $data[2]=$this->cb_contact_cct_name[$i][$j];
          return($data);
        }
    return(-1);
  }

  function load_contacts()
  {
    for($i=0; $i < $this->cb_count; $i++)
    {
      $this->SQL->SQLquery("SELECT cct.cct_name, cc.i_id, cc.cc_nr, i.i_forename, i.i_surname FROM company_contact cc, company_ctype cct, identity i WHERE cc.cb_id=".$this->cb_id[$i]." AND cct.cct_id=cc.cc_type_id AND i.i_id=cc.i_id AND i.i_status='V' AND cc.cc_status='V'");
      $num=$this->SQL->SQLnum_rows();
      $this->cb_contact_count[$i]=$num;
      if($num != 0)
      {
        for($j=0; $j < $num; $j++)
        {
          $row=$this->SQL->SQLfetch_array($j);
          $this->cb_contact_i_id[$i][$j]=$row[i_id];
          $this->cb_contact_cc_nr[$i][$j]=$row[cc_nr];
          $this->cb_contact_i_name[$i][$j]=$row[i_forename]." ".$row[i_surname];
          $this->cb_contact_cct_name[$i][$j]=$row[cct_name];
        }
      }
    }
    return(1);
  }

  function get_contactdetail($ac_id)
  {
    $this->SQL->SQLquery("SELECT ac.a_id, ac.ac_data, act.act_name FROM address_contact ac, address_ctype act WHERE ac.ac_id=".$ac_id." AND ac.ac_status='V' AND ac.act_id=act.act_id");
    $num=$this->SQL->SQLnum_rows();
    if($num>1)
      return -2;
    if($num<1)
      return -1;
    if($num==1)
    {
      $row=$this->SQL->SQLfetch_array(0);
      $data[0]=$row[act_name];
      $data[1]=$row[ac_data];
      $data[2]=$row[a_id];
    }
    return($data);
  }
}

class CBranch extends Company
{
  function CBranch($SQL, $cfg, $cb_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    if(empty($cb_id))
    {
      echo("ERROR: no company branch id given!\n");
      return(-1);
    }
    if($cb_id >= 0)
    {
      $SQL->SQLquery("SELECT c_id FROM company_branch WHERE cb_id='$cb_id' AND cb_status='V'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        Company::Company($SQL, $cfg, $row[c_id]);
      }
      else
        return(-1);
    }
    else
      return(-1);
    return(1);
  }
}

class Document
{
  var $SQL;
  var $cfg;
  var $d_id;
  var $us_id;
  var $d_author_id;
  var $d_desc;
  var $d_keywords;
  var $d_ctime;
  var $d_cdate;
  var $d_hist_id;
  var $df_id;
  var $df_name;
  var $df_type;
  var $df_size;
  var $pd_pdnr;
  var $pd_rlevel;
  var $pd_rev;

  function Document($SQL, $cfg, $d_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    else
      $this->SQL = $SQL;
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    else
      $this->cfg = $cfg;
    if(empty($d_id))
    {
      echo("ERROR: no identity given!\n");
      return(-1);
    }
    else
      $this->d_id = $d_id;
    if($this->d_id >= 0)
    {
      $SQL->SQLquery("SELECT d.d_id, d.d_hist_id, d.us_id , d.d_author_id, d.d_desc, d.d_keywords, d.d_ctime, d.d_cdate, pd.p_id, pd.pd_pdnr, pd.pd_rlevel, pd.pd_rev FROM document d, project_doc pd WHERE d.d_id='$this->d_id' AND pd.d_id=d.d_id AND d.d_status='V' AND pd.pd_status='V'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        $this->d_id = $row[d_id];
        $this->us_id = $row[us_id];
        $this->d_author_id = $row[d_author_id];
        $this->d_desc = $row[d_desc];
        $this->d_keywords = $row[d_keywords];
        $this->d_ctime = $row[d_ctime];
        $this->d_cdate = $row[d_cdate];
        $this->d_hist_id = $row[d_hist_id];
        $this->p_id = $row[p_id];
        $this->pd_pdnr = $row[pd_pdnr];
        $this->pd_rlevel = $row[pd_rlevel];
        $this->pd_rev = $row[pd_rev];
        $SQL->SQLquery("SELECT df_id, df_name, df_type, df_size FROM document_format WHERE d_id='$this->d_id' AND df_status='V'");
        $num=$SQL->SQLnum_rows();
        for($i=0; $i<$num; $i++)
        {
          $row=$SQL->SQLfetch_array($i);
          $this->df_id[$i]=$row[df_id];
          $this->df_name[$i]=$row[df_name];
          $this->df_type[$i]=$row[df_type];
          $this->df_size[$i]=$row[df_size];
        }
        return(0);
      }
    }
    else
      return(-1);
  }

  function get_internalnumber($df_id)
  {
    for($i=0; $i < count($this->df_id); $i++)
      if($this->df_id[$i] == $df_id)
        return($i);
    return(-1);
  }

  function get_reportref($df_id)
  {
    $this->SQL->SQLquery("SELECT ud.ud_acronym FROM users u, user_department ud WHERE u.i_id='$this->d_author_id' AND u.ud_id=ud.ud_id AND (u.u_status='D' OR u.u_status='V')");
    if($this->SQL->SQLnum_rows() != 0)
    {
      $row=$this->SQL->SQLfetch_array(0);
      $ref=$row[ud_acronym];
      $this->SQL->SQLquery("SELECT us_acronym FROM user_subdepartment WHERE us_id='$this->us_id'");
      if($this->SQL->SQLnum_rows() != 0)
      {
        $row=$this->SQL->SQLfetch_array(0);
        $ref.="_".$row[us_acronym];
      }
      $this->SQL->SQLquery("SELECT c.c_acronym, cb.cb_acronym, p.p_acronym FROM company c, company_branch cb, project p, project_company pco WHERE p.p_id='$this->p_id' AND p.p_id=pco.p_id AND pco.cb_id=cb.cb_id AND cb.c_id=c.c_id AND p.p_status='V' AND pco.pco_status='V' AND cb.cb_status='V' AND c.c_status='V'");
      if($this->SQL->SQLnum_rows() != 0)
      {
        $row=$this->SQL->SQLfetch_array(0);
        $ref.="-".$row[c_acronym]."_".$row[cb_acronym]."-".$row[p_acronym];
      }
      if(empty($df_id))
        $ref.="-".$this->pd_rlevel."-".$this->pd_pdnr."-".$this->pd_rev;
      else
      {
        $this->SQL->SQLquery("SELECT df.df_name, pd.pd_rlevel, pd.pd_pdnr, pd.pd_rev FROM project_doc pd, document_format df WHERE pd.p_id='$this->p_id' AND pd.d_id='$this->d_id' AND pd.d_hist_id=df.d_hist_id AND df.df_id='$df_id'");
        if($this->SQL->SQLnum_rows() != 0)
        {
          $row=$this->SQL->SQLfetch_array(0);
          $ref.="-".$row[pd_rlevel]."-".$row[pd_pdnr]."-".$row[pd_rev].".".get_extension($row[df_name]);
        }
        else
          return(-1);
      }
    }
    return($ref);
  }

  function get_history()
  {
    $SQL2 = init($this->cfg);
    $this->SQL->SQLquery("SELECT ud.ud_acronym, p.p_acronym, c.c_acronym, cb.cb_acronym, p.p_acronym, d.d_desc, d.us_id, i.i_forename, i.i_surname, d.d_cdate, d.d_ctime, df.df_id, df.df_name, df.df_type, df.df_size, pd.pd_rlevel, pd.pd_rev, pd.pd_pdnr FROM document d, document_format df, project_doc pd, identity i, users u, user_department ud, company c, company_branch cb, project p, project_company pco WHERE d.d_id='".$this->d_id."' AND df.d_id=d.d_id AND df.d_hist_id=d.d_hist_id AND pd.d_hist_id=d.d_hist_id AND pd.d_id=d.d_id AND d.d_author_id=i.i_id AND d.d_author_id=u.i_id AND u.ud_id=ud.ud_id AND pd.p_id=p.p_id AND p.p_id=pco.p_id AND pco.cb_id=cb.cb_id AND cb.c_id=c.c_id AND u.u_status='V' AND p.p_status='V' AND pco.pco_status='V' AND cb.cb_status='V' AND c.c_status='V' AND pd.pd_status='U' AND d.d_status='U' AND df.df_status='U' AND i.i_status='V'");
    $num=$this->SQL->SQLnum_rows();
    for($i=0; $i<$num; $i++)
    {
      $row=$this->SQL->SQLfetch_array($i);
      $SQL2->SQLquery("SELECT us_acronym FROM user_subdepartment WHERE us_id='".$row[us_id]."'");
      if($SQL2->SQLnum_rows() != 0)
      {
        $row2=$SQL2->SQLfetch_array(0);
        $data[$i][0]=$row[ud_acronym]."-".$row2[us_acronym];
      }
      else
        $data[$i][0]=$row[ud_acronym];
      $data[$i][0].="-".$row[c_acronym]."_".$row[cb_acronym]."-".$row[p_acronym]."-".$row[pd_rlevel]."-".$row[pd_pdnr]."-".$row[pd_rev].".".get_extension($row[df_name]);
      $data[$i][1]=number_format($row[df_size], 0, ".", ",")." KB";
      $data[$i][2]=$row[i_forename]." ".$row[i_surname];
      $data[$i][3]=reformat_date($row[d_cdate])." ".$row[d_ctime];
      $data[$i][4]=$row[d_desc];
      $data[$i][5]=$row[df_id];
    }
    return($data);
  }
}

class FDocument extends Document
{
  function FDocument($SQL, $cfg, $df_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    if(empty($df_id))
    {
      echo("ERROR: no identity given!\n");
      return(-1);
    }
    if(df_id >= 0)
    {
      $SQL->SQLquery("SELECT d_id FROM document_format WHERE df_id='$df_id' AND (df_status='V' or df_status='U')");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        Document::Document($SQL, $cfg, $row[d_id]);
        return(0);
      }
      else
        return(-1);
    }
    else
      return(-1);
  }
}

class Project
{
  var $SQL;
  var $cfg;
  var $ud_id;
  var $department;
  var $p_id;
  var $p_name;
  var $p_acronym;
  var $p_start;
  var $p_end;
  var $p_pstatus;
  var $p_description;
  var $p_comment;
  var $contacts;
  var $cb_id;
  var $cb_name;
  var $cb_acronym;
  var $c_name;

  function Project($SQL, $cfg, $p_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    else
      $this->SQL = $SQL;
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    else
      $this->cfg = $cfg;
    if(empty($p_id))
    {
      echo("ERROR: no identity given!\n");
      return(-1);
    }
    else
      $this->p_id = $p_id;
    if($this->p_id >= 0)
    {
      $SQL->SQLquery("SELECT p.p_name, p.p_acronym, p.p_start, p.p_end, p.psta_id, p.p_description, p.p_comment, p.ud_id, cb.cb_id, cb.cb_name, cb.cb_acronym, c.c_name FROM project p, project_company pco, company_branch cb, company c WHERE p.p_id='$this->p_id' AND pco.p_id=p.p_id AND pco.cb_id=cb.cb_id AND c.c_id=cb.c_id AND c.c_status='V' AND p.p_status='V' AND pco.pco_status='V' AND cb.cb_status='V'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        $this->p_name = $row[p_name];
        $this->p_acronym = $row[p_acronym];
        $this->p_start = $row[p_start];
        $this->p_end = $row[p_end];
        $this->p_description = $row[p_description];
        $this->p_comment = $row[p_comment];
        $this->ud_id = $row[ud_id];
        $this->cb_id = $row[cb_id];
        $this->cb_name = $row[cb_name];
        $this->cb_acronym = $row[cb_acronym];
        $this->c_name = $row[c_name];
        $SQL->SQLquery("SELECT psta_name, psta_acronym FROM project_status WHERE psta_id='$row[psta_id]' AND psta_status='V'");
        if($SQL->SQLnum_rows() != 0)
        {
          $row=$SQL->SQLfetch_array(0);
          $this->p_pstatus[0] = $row[psta_name];
          $this->p_pstatus[1] = $row[psta_acronym];
        }
        $SQL->SQLquery("SELECT ud_name FROM user_department WHERE ud_id='".$this->ud_id."'");
        if($SQL->SQLnum_rows() != 0)
        {
          $row=$SQL->SQLfetch_array(0);
          $this->department = $row[ud_name];
        }
      }
      return(1);
    }
  }

  function delete_project()
  {
    $this->SQL->SQLquery("UPDATE project SET p_status='D' WHERE p_id='".$this->p_id."' AND p_status='V'");
    return("<H1>Project ".$this->p_name." deleted!</H1>\n");
  }

  function load_contacts()
  {
    $this->SQL->SQLquery("SELECT i_id FROM project_contact WHERE p_id='".$this->p_id."' AND pc_status='V'");
    $num=$this->SQL->SQLnum_rows();
    for($i=0; $i<$num; $i++)
    {
      $row=$this->SQL->SQLfetch_array($i);
      $this->contacts[$i]=$row[i_id];
    }
    return($num);
  }

  function remove_compconp($i_id)
  {
    if(empty($this->contacts))
      $nump=$this->load_contacts();

    $cnr=-1;
    for($j=0; $j<$nump; $j++)
      if($project->contacts[$j] == $ri_id)
        $cnr=$j;
    if($cnr==-1)
      return("<H1>Sorry, this person is not a contact person in this project (".$this->p_name.")!</H1>\n");

    $this->SQL->SQLquery("UPDATE project_contact SET pc_status='D' WHERE p_id='".$this->p_id."' AND i_id='".$i_id."' AND pc_status='V'");
    return("<H1>Contact removed!</H1>\n");
  }

  function remove_staff($i_id, $pst_id)
  {
    $data=$this->get_staff_iid($i_id);
    $cnr=-1;
    for($j=0; $j<count($data); $j++)
      if($data[$j][5] == $pst_id)
        $cnr=$j;
    if($cnr==-1)
      return("<H1>Sorry, invalid team member and/or position given!</H1>\n");

    $this->SQL->SQLquery("UPDATE project_staff SET ps_status='D' WHERE p_id='".$this->p_id."' AND i_id='".$i_id."' AND pst_id='".$pst_id."' AND ps_status='V'");
    return("<H1>Contact removed!</H1>\n");
  }

  function add_staff($i_id, $pst_id, $user)
  {
    $this->SQL->SQLquery("SELECT ps_nr FROM project_staff WHERE ps_status='V' AND p_id='".$this->p_id."' AND i_id='".$i_id."' AND pst_id='".$pst_id."'");
    if($this->SQL->SQLnum_rows() !=0)
      return("<H1>The selected person is already in the project (".$this->p_name.") with this position!</H1>\n");
    $this->SQL->SQLquery("SELECT pst_id FROM project_stype WHERE pst_id='".$pst_id."'");
    if($this->SQL->SQLnum_rows() == 0)
      return("<H1>The selected postition is not in the database!</H1>\n");

    $this->SQL->SQLquery("INSERT INTO project_staff(p_id, i_id, pst_id, ps_status, ps_creator_id) VALUES('".$this->p_id."', '".$i_id."', '".$pst_id."', 'V', '".$user->i_id."')");
    return("<H1>Contact added!</H1>\n");
  }

  function get_staff_iid($i_id)
  {
    $this->SQL->SQLquery("SELECT ps.i_id, i.i_forename, i.i_surname, pst.pst_name, pst.pst_acronym, pst.pst_id FROM project_staff ps, identity i, project_stype pst WHERE ps.ps_status='V' AND i.i_status='V' AND ps.p_id='".$this->p_id."' AND ps.i_id=i.i_id AND ps.pst_id=pst.pst_id AND ps.i_id='".$i_id."'");
    $num=$this->SQL->SQLnum_rows();
    for($i=0; $i<$num; $i++)
    {
      $row=$this->SQL->SQLfetch_array($i);
      $data[$i][0]=$row[i_id];
      $data[$i][1]=$row[i_forename];
      $data[$i][2]=$row[i_surname];
      $data[$i][3]=$row[pst_name];
      $data[$i][4]=$row[pst_acronym];
      $data[$i][5]=$row[pst_id];
    }
    return($data);
  }

  function get_staff_list($order)
  {
    switch($order)
    {
      case "forename":
        $neworder="i.i_forename";
        break;
      case "surname":
        $neworder="i.i_surname";
        break;
      case "posname":
        $neworder="pst.pst_name";
        break;
      case "posacronym":
        $neworder="pst.pst_acronym";
        break;
      default:
        $neworder="ps.i_id";
    }
    $this->SQL->SQLquery("SELECT ps.i_id, i.i_forename, i.i_surname, pst.pst_name, pst.pst_acronym FROM project_staff ps, identity i, project_stype pst WHERE ps.ps_status='V' AND i.i_status='V' AND ps.p_id='".$this->p_id."' AND ps.i_id=i.i_id AND ps.pst_id=pst.pst_id ORDER BY ".$neworder);
    $num=$this->SQL->SQLnum_rows();
    for($i=0; $i<$num; $i++)
    {
      $row=$this->SQL->SQLfetch_array($i);
      $data[$i][0]=$row[i_id];
      $data[$i][1]=$row[i_forename];
      $data[$i][2]=$row[i_surname];
      $data[$i][3]=$row[pst_name];
      $data[$i][4]=$row[pst_acronym];
    }
    return($data);
  }

  function get_staff_role($role)
  {
    $notnum=0;
    $num=0;
    for($i=0; $i<count($role); $i++)
    {
     if($role[$i][0]=="!")
     {
       $not="";
       for($j=1; $j<strlen($role[$i]); $j++)
         $not.=$role[$i][$j];
       $wheren[$notnum]=" pst.pst_acronym='".$not."' ";
       $notnum++;
     }
     else
     {
       $where[$num]=" pst.pst_acronym='".$role[$i]."' ";
       $num++;
     }
    }
    if($notnum!=0 OR $num!=0)
    {
      if($num==0)
        $wherestring=" AND NOT (";
      else
        $wherestring=" AND  (";
      if($num>0)
      {
        $wherestring.="(";
        for($i=0; $i<$num; $i++)
        {
          $wherestring.=$where[$i];
          if(($i+1) != $num)
            $wherestring.="OR";
        }
        $wherestring.=")";
      }
      if($num!=0 AND $notnum!=0)
        $wherestring.=" AND NOT ";
      if($notnum>0)
      {
        $wherestring.="(";
        for($i=0; $i<$notnum; $i++)
        {
          $wherestring.=$wheren[$i];
          if(($i+1) != $notnum)
            $wherestring.="OR";
        }
        $wherestring.=")";
      }
      $wherestring.=")";
    }
    $this->SQL->SQLquery("SELECT ps.i_id, i.i_forename, i.i_surname, pst.pst_name, pst.pst_acronym, pst.pst_id FROM project_staff ps, identity i, project_stype pst WHERE ps.ps_status='V' AND i.i_status='V' AND ps.p_id='".$this->p_id."' ".$wherestring." AND ps.i_id=i.i_id AND ps.pst_id=pst.pst_id");
    $num=$this->SQL->SQLnum_rows();
    for($i=0; $i<$num; $i++)
    {
      $row=$this->SQL->SQLfetch_array($i);
      $data[$i][0]=$row[i_id];
      $data[$i][1]=$row[i_forename];
      $data[$i][2]=$row[i_surname];
      $data[$i][3]=$row[pst_name];
      $data[$i][4]=$row[pst_acronym];
      $data[$i][5]=$row[pst_id];
    }
    return($data);
  }
}

class User extends Identity
{
  var $u_nr;
  var $u_name;
  var $uc_id;
  var $ud_id = -1;
  var $uw_id;
  var $uw_id_data;
  var $god=0;

  function User($SQL, $cfg, $i_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    else
      $this->SQL = $SQL;
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    else
      $this->cfg = $cfg;
    if(empty($i_id))
    {
      echo("ERROR: no identity given!\n");
      return(-1);
    }
    else
      $this->i_id = $i_id;
    if($this->i_id >= 0)
    {
      $SQL->SQLquery("SELECT u_nr, u_name, uc_id, uw_id FROM users WHERE i_id='$this->i_id' AND u_status='V'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        $this->u_nr = $row[u_nr];
        $this->u_name = $row[u_name];
        $this->uc_id = $row[uc_id];
        $this->uw_id = $row[uw_id];
      }
      $SQL->SQLquery("SELECT ugo_nr FROM user_god WHERE i_id='$this->i_id' AND ugo_status='V'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        $this->god = 1;
      }
      $SQL->SQLquery("SELECT * FROM user_windowsize WHERE uw_id='$this->uw_id'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        $this->uw_id_data[0] = $row[uw_full];
        $this->uw_id_data[1] = $row[uw_main];
        $this->uw_id_data[2] = $row[uw_small];
      }
      Identity::Identity ($SQL, $cfg, $i_id);
      return(1);
    }
  }

  function getpwd()
  {
    $this->SQL->SQLquery("SELECT u_password FROM users WHERE i_id='$this->i_id' AND u_status='V'");
    if($this->SQL->SQLnum_rows() != 0)
    {
      $row=$this->SQL->SQLfetch_array(0);
      return($row[u_password]);
    }
    else
      return(-1);
  }

  function getdepartment()
  {
    $this->SQL->SQLquery("SELECT ud.ud_name, ud.ud_id FROM users u, user_department ud WHERE u.i_id='$this->i_id' AND u.ud_id=ud.ud_id AND u.u_status='V'");
    if($this->SQL->SQLnum_rows() != 0)
    {
      $row=$this->SQL->SQLfetch_array(0);
      $this->ud_id=$row[ud_id];
      return($row[ud_name]);
    }
    else
      return(-1);
  }

  function getcolorscheme()
  {
    $this->SQL->SQLquery("SELECT uc.uc_name, uc.uc_id FROM users u, user_colortemplate uc WHERE u.i_id='$this->i_id' AND u.uc_id=uc.uc_id AND u.u_status='V'");
    if($this->SQL->SQLnum_rows() != 0)
    {
      $row=$this->SQL->SQLfetch_array(0);
      $this->uc_id=$row[uc_id];
      return($row[uc_name]);
    }
    else
      return(-1);
  }
}

// We need this class because you can't have multiple constructors in PHP4
class UserbyNr extends User
{

  function UserbyNr($SQL, $cfg, $u_nr)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    if(empty($u_nr))
    {
      echo("ERROR: no user given!\n");
      return(-1);
    }
    if($u_nr >= 0)
    {
      $SQL->SQLquery("SELECT i_id FROM users WHERE u_nr='$u_nr' AND u_status='V'");
      if($SQL->SQLnum_rows() != 0)
      {
        $row=$SQL->SQLfetch_array(0);
        $i_id = $row[i_id];
      }
      User::User ($SQL, $cfg, $i_id);
      return(1);
    }
  }
}

class TPage extends Page
{
  var $tct_uc_id;
  
  function TPage($SQL, $cfg, $user, $submenu, $title, $tct_uc_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    if(empty($user))
    {
      echo("ERROR: no user given!\n");
      return(-1);
    }
    if(empty($submenu))
    {
      echo("ERROR: no valid submenu selected!\n");
      return(-1);
    }
    if(empty($title))
    {
      echo("ERROR: no valid pagetitle given!\n");
      return(-1);
    }
    if(empty($tct_uc_id))
    {
      echo("ERROR: no color id given!\n");
      return(-1);
    }
    else
      $this->tct_uc_id=$tct_uc_id;

    Page::Page($SQL, $cfg, $user, $submenu, $title);
    return(1);
  }
}

class SPage extends Page
{
  
  function SPage($SQL, $cfg, $user, $submenu, $title, $uw_id)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    if(empty($user))
    {
      echo("ERROR: no user given!\n");
      return(-1);
    }
    if(empty($submenu))
    {
      echo("ERROR: no valid submenu selected!\n");
      return(-1);
    }
    if(empty($title))
    {
      echo("ERROR: no valid pagetitle given!\n");
      return(-1);
    }
    if(empty($uw_id))
    {
      echo("ERROR: no windowsize id given!\n");
      return(-1);
    }

    Page::Page($SQL, $cfg, $user, $submenu, $title);
    $this->user->uw_id = $uw_id;
    $SQL->SQLquery("SELECT * FROM user_windowsize WHERE uw_id='$uw_id'");
    if($SQL->SQLnum_rows() != 0)
    {
      $row=$SQL->SQLfetch_array(0);
      $this->user->uw_id_data[0] = $row[uw_full];
      $this->user->uw_id_data[1] = $row[uw_main];
      $this->user->uw_id_data[2] = $row[uw_small];
    }

    return(1);
  }
}

class Page
{
  var $SQL;
  var $cfg;
  var $user;
  var $pagetitle;
  var $submenu;
  var $content;
  
  function Page($SQL, $cfg, $user, $submenu, $title)
  {
    if(empty($SQL))
    {
      echo("ERROR: no valid SQL connection!\n");
      return(-1);
    }
    else
      $this->SQL = $SQL;
    if(empty($cfg))
    {
      echo("ERROR: Please configure your system!\n");
      return(-1);
    }
    else
      $this->cfg = $cfg;
    if(empty($user))
    {
      echo("ERROR: no user given!\n");
      return(-1);
    }
    else
      $this->user = $user;
    if(empty($submenu))
    {
      echo("ERROR: no valid submenu selected!\n");
      return(-1);
    }
    else
      $this->submenu = $submenu;
    if(empty($title))
    {
      echo("ERROR: no valid pagetitle given!\n");
      return(-1);
    }
    else
      $this->pagetitle = $title;
    return(1);
  }

  function content($content)
  {
    $this->content.=$content;
  }

  function print_css($cssline)
  {
    echo("<META HTTP-EQUIV=\"Expires\" CONTENT=\"".gmdate("l, d F Y H:i:s")." GMT\">\n");
    echo("<META HTTP-EQUIV=\"Last-Modified\" CONTENT=\"".gmdate("l, d F Y H:i:s")." GMT\">\n");
    echo("<META HTTP-EQUIV=\"Cache-Control\" CONTENT=\"no-cache, must-revalidate\">\n");
    echo("<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n");
    echo($cssline);
    echo("<STYLE TYPE=\"text/css\">\n");
    if(!empty($this->tct_uc_id))
      $this->SQL->SQLquery("SELECT uc_l_link, uc_l_visited, uc_l_active, uc_b_c, uc_mb_bgc, uc_mb_c, uc_mi_bgc, uc_mi_c, uc_mh_bgc, uc_mh_c FROM user_colortemplate WHERE uc_id='".$this->tct_uc_id."' AND uc_status='V'");
    else
      $this->SQL->SQLquery("SELECT uc_l_link, uc_l_visited, uc_l_active, uc_b_c, uc_mb_bgc, uc_mb_c, uc_mi_bgc, uc_mi_c, uc_mh_bgc, uc_mh_c FROM user_colortemplate WHERE uc_id='".$this->user->uc_id."' AND uc_status='V'");
    if($this->SQL->SQLnum_rows() != 0)
      $row=$this->SQL->SQLfetch_array(0);
    else
    { // This is the default color design
      $this->SQL->SQLquery("SELECT uc_l_link, uc_l_visited, uc_l_active, uc_b_c, uc_mb_bgc, uc_mb_c, uc_mi_bgc, uc_mi_c, uc_mh_bgc, uc_mh_c FROM user_colortemplate WHERE uc_id=1 AND uc_status='V'");
      $row=$this->SQL->SQLfetch_array(0);
    }
    echo("a:link { color:#".$row[uc_l_link]."; }\n");
    echo("a:visited { color:#".$row[uc_l_visited]."; }\n");
    echo("a:active { color:#".$row[uc_l_active]."; front_style:italic }\n");
    echo("body { background-color:".$row[uc_b_c]."; }\n");
    echo("#menuborder { font-family:arial,sans-serif; font-size:10px; color:#".$row[uc_mb_c]."; background-color:#".$row[uc_mb_bgc]."; }\n");
    echo("#menuitem { font-family:arial,sans-serif; font-size:12px; color:#".$row[uc_mi_c]."; background-color:#".$row[uc_mi_bgc]."; }\n");
    echo("#menuhead { font-family:arial,sans-serif; font-size:12px; color:#".$row[uc_mh_c]."; background-color:#".$row[uc_mh_bgc]."; }\n");
    echo("#black8 { font-family:arial,sans-serif; font-size:8px; color:#000000; }\n");
    echo("#black10 { font-family:arial,sans-serif; font-size:10px; color:#000000; }\n");
    echo("#black8 { font-family:arial,sans-serif; font-size:12px; color:#000000; }\n");
    echo("</STYLE>\n");
  }

  function print_mainmenu()
  {
    echo "<A HREF=\"".$this->cfg[homeurl]."/index.php\">Home</A> \n";
    echo "<A HREF=\"".$this->cfg[homeurl]."/contacts/info.php\">Contacts</A> \n";
    echo "<A HREF=\"".$this->cfg[homeurl]."/companies/info.php\">Companies</A> \n";
    echo "<A HREF=\"".$this->cfg[homeurl]."/projects/info.php\">Projects</A> \n";
    echo "<A HREF=\"".$this->cfg[homeurl]."/documents/info.php\">Documents</A> \n";
    echo "<A HREF=\"".$this->cfg[homeurl]."/users/config.php\">Config</A> \n";
    if($this->user->god)
    {
      echo "<A HREF=\"".$this->cfg[homeurl]."/users/list.php\">Admin</A> \n";
    }
    echo "<A HREF=\"".$this->cfg[homeurl]."/logout.php\">Logout</A>\n";
  }

  function print_submenu()
  {
    switch($this->submenu)
    {
      case "logout":
      {
        echo("&nbsp;\n");
        break;
      }
      case "home":
      {
        echo("<A HREF=\"".$this->cfg[homeurl]."/users/config.php?i_id=".$this->user->i_id."\">Personal Settings</A>\n");
        //echo("<A HREF=\"".$this->cfg[homeurl]."/timemanagement/info.php\">Timemanagement</A>\n");
        break;
      }
      case "config":
      {
        echo("<A HREF=\"".$this->cfg[homeurl]."/users/config.php\">Account</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/users/color.php\">Colors</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/users/size.php\">Size</A>\n");
        break;
      }
      case "admin":
      {
        echo("<A HREF=\"".$this->cfg[homeurl]."/users/list.php\">List Users</A>\n");
        if($this->user->god == 1)
        {
          echo("<A HREF=\"".$this->cfg[homeurl]."/users/user-new.php\">New User</A>\n");
          echo("<A HREF=\"".$this->cfg[homeurl]."/admin/department-list.php\">Departments</A>\n");
          echo("<A HREF=\"".$this->cfg[homeurl]."/admin/generic.php?action=pst-list\">Staff roles</A>\n");
          echo("<A HREF=\"".$this->cfg[homeurl]."/admin/generic.php?action=drl-list\">Report level</A>\n");
          echo("<A HREF=\"".$this->cfg[homeurl]."/admin/generic.php?action=cct-list\">Job titles</A>\n");
          echo("<A HREF=\"".$this->cfg[homeurl]."/admin/generic.php?action=act-list\">Contact types</A>\n");
          echo("<A HREF=\"".$this->cfg[homeurl]."/admin/generic.php?action=aco-list\">Address countries</A>\n");
          echo("<A HREF=\"".$this->cfg[homeurl]."/admin/generic.php?action=col-list\">Colors</A>\n");
          echo("<A HREF=\"".$this->cfg[homeurl]."/admin/generic.php?action=win-list\">Window size</A>\n");
        }
        break;
      }
      case "company":
      {
        echo("<A HREF=\"".$this->cfg[homeurl]."/companies/info.php\">Info</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/companies/list.php\">List</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/companies/company-new.php\">New Company</A>\n");
        break;
      }
      case "contact":
      {
        echo("<A HREF=\"".$this->cfg[homeurl]."/contacts/info.php\">Info</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/contacts/list.php\">List</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/contacts/identity-new.php\">New</A>\n");
        break;
      }
      case "project":
      {
        echo("<A HREF=\"".$this->cfg[homeurl]."/projects/info.php\">Info</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/projects/list.php\">List</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/projects/project-new.php\">New</A>\n");
        break;
      }
      case "document":
      {
        echo("<A HREF=\"".$this->cfg[homeurl]."/documents/info.php\">Info</A>\n");
        break;
      }
      case "time":
      {
        echo("<A HREF=\"".$this->cfg[homeurl]."/timemanagement/week-edit.php\">Edit Week</A>\n");
        echo("<A HREF=\"".$this->cfg[homeurl]."/timemanagement/forecast-edit.php\">Edit Workloadforcast</A>\n");
        break;
      }
    }
  }

  function print_projectlinks()
  {
    if($this->user < 0)
    {
      echo("                  Not logged in\n");
      return(0);
    }

    $this->SQL->SQLquery("SELECT DISTINCT ON(p.p_id) p.p_id, p.p_name, MAX(ps.pst_id), pst.pst_acronym FROM project p, project_staff ps, project_stype pst, project_status psta WHERE p.p_id=ps.p_id AND ps.i_id='".$this->user->i_id."' AND pst.pst_id=ps.pst_id AND p.psta_id = psta.psta_id AND psta.psta_acronym!='CLOSED' AND psta.psta_status='V' AND p.p_status='V' AND ps.ps_status='V' GROUP BY p.p_id, p.p_name, pst.pst_acronym LIMIT 10");
    $num=$this->SQL->SQLnum_rows();
    if($num != 0)
    {
      for($i=0; $i < $num; $i++)
      {
        $row=$this->SQL->SQLfetch_array($i);
        echo("                  <A HREF=\"".$this->cfg[homeurl]."/projects/detail.php?vp_id=".$row[p_id]."\">".$row[p_name]."</A> (".$row[pst_acronym].")<BR>\n");

      }
    }
    else
        echo("                  n/a<BR>\n");
  }

  function print_shortcuts()
  {
    global $scp_id;
    global $scc_id;
    global $sccb_id;
    global $sci_id;

    if($scp_id == 0)
      echo("          <TD ALIGN=center ID=menuhead>PROJECT: none</TD>\n");
    else
    {
      $project = new Project($this->SQL, $this->cfg, $scp_id);
      echo("          <TD ALIGN=center ID=menuhead>PROJECT: <A HREF=\"".$this->cfg[homeurl]."/projects/detail.php?vp_id=".$scp_id."\">".$project->p_name."</A> (".$project->p_acronym.")</TD>\n");
    }
    if($sccb_id != 0)
    {
      $company = new CBranch($this->SQL, $this->cfg, $sccb_id);
      echo("          <TD ALIGN=center ID=menuhead>COMPANY-BRANCH: <A HREF=\"".$this->cfg[homeurl]."/companies/detail.php?cb_id=".$sccb_id."\">".$company->c_name."-".$company->cb_name[$company->get_ibranchnr($sccb_id)]."</A> (".$company->c_acronym."-".$company->cb_acronym[$company->get_ibranchnr($sccb_id)].")</TD>\n");
    }
    else
    {
      if($scc_id != 0)
      {
        $company = new Company($this->SQL, $this->cfg, $scc_id);
        echo("          <TD ALIGN=center ID=menuhead>COMPANY: <A HREF=\"".$this->cfg[homeurl]."/companies/detail.php?c_id=".$scc_id."\">".$company->c_name."</A> (".$company->c_acronym.")</TD>\n");
      }
      else
        echo("          <TD ALIGN=center ID=menuhead>COMPANY: none</TD>\n");
    }
    if($sci_id == 0)
      echo("          <TD ALIGN=center ID=menuhead>CONTACT: none</TD>\n");
    else
    {
      $identity = new Identity($this->SQL, $this->cfg, $sci_id);
      echo("          <TD ALIGN=center ID=menuhead>CONTACT: <A HREF=\"".$this->cfg[homeurl]."/contacts/list.php?vi_id=".$sci_id."\">".$identity->i_forename." ".$identity->i_surname."</A></TD>\n");
    }
  }

  function show2($cssline)
  {
    echo("<HTML>\n");
    echo("<HEAD>\n");
    echo("<TITLE>".$this->pagetitle."</TITLE>\n");
    $this->print_css($cssline);
    echo("</HEAD>\n");
    echo("<BODY>\n\n");
    if(empty($this->user->uw_id_data[0]))
      echo("<TABLE WIDTH=900 BORDER=0 CELLPADDING=0 CELLSPACEING=2>\n");
    else
      echo("<TABLE WIDTH=".$this->user->uw_id_data[0]." BORDER=0 CELLPADDING=0 CELLSPACEING=2>\n");
    echo("  <TR>\n");
    echo("    <TD ID=menuborder>\n");
    echo("      <TABLE WIDTH=100% BORDER=0 CELLPADDING=1 CELLSPACEING=1>\n");
    echo("        <TR>\n");
    echo("          <TD ID=menuhead ALIGN=left>Logged in as: ".$this->user->name."</TD>\n");
    if($this->user->god) 
      echo("          <TD ID=menuhead WIDTH=48% ALIGN=right>\n");
    else
      echo("          <TD ID=menuhead WIDTH=40% ALIGN=right>\n");
    $this->print_mainmenu();
    echo("          </TD>\n");
    echo("        </TR>\n");
    echo("      </TABLE>\n");
    echo("    </TD>\n");
    echo("  </TR>\n");
    echo("</TABLE>\n");
    if(empty($this->user->uw_id_data[0]))
      echo("<TABLE WIDTH=900 BORDER=0 CELLPADDING=0 CELLSPACEING=2>\n");
    else
      echo("<TABLE WIDTH=".$this->user->uw_id_data[0]." BORDER=0 CELLPADDING=0 CELLSPACEING=2>\n");
    echo("  <TR>\n");
    echo("    <TD ID=menuborder WIDTH=".$this->user->uw_id_data[2].">\n");
    echo("      <TABLE WIDTH=100% BORDER=0 CELLPADDING=1 CELLSPACEING=2>\n");
    echo("        <TR>\n");
    echo("          <TD ID=menuhead>".date("l, d.m.Y")."</TD>\n");
    echo("        </TR>\n");
    echo("      </TABLE>\n");
    echo("    </TD>\n");
    if(empty($this->user->uw_id_data[1]))
      echo("    <TD ID=menuborder WIDTH=750>\n");
    else
      echo("    <TD ID=menuborder WIDTH=".$this->user->uw_id_data[1].">\n");
    echo("      <TABLE WIDTH=100% BORDER=0 CELLPADDING=1 CELLSPACEING=2 HEIGHT=100%>\n");
    echo("        <TR>\n");
    echo("          <TD ID=menuhead>\n");
    $this->print_submenu();
    echo("          </TD>\n");
    echo("        </TR>\n");
    echo("      </TABLE>\n");
    echo("    </TD>\n");
    echo("  </TR>\n");
    echo("</TABLE>\n");
    if(empty($this->user->uw_id_data[0]))
      echo("<TABLE WIDTH=900 BORDER=0 CELLPADDING=0 CELLSPACEING=0>\n");
    else
      echo("<TABLE WIDTH=".$this->user->uw_id_data[0]." BORDER=0 CELLPADDING=0 CELLSPACEING=0>\n");
    echo("  <TR>\n");
    if(empty($this->user->uw_id_data[2]))
      echo("    <TD WIDTH=150 VALIGN=top>\n");
    else
      echo("    <TD WIDTH=".$this->user->uw_id_data[2]." VALIGN=top>\n");
    echo("      <TABLE WIDTH=100% BORDER=0 CELLPADDING=0 CELLSPACEING=1>\n");
    echo("        <TR>\n");
    echo("          <TD ID=menuborder>\n");
    echo("            <TABLE WIDTH=100% BORDER=0 CELLPADDING=1 CELLSPACEING=1>\n");
    echo("              <TR>\n");
    echo("                <TD ID=menuhead> Projects </TD>\n");
    echo("              </TR>\n");
    echo("              <TR>\n");
    echo("                <TD ID=menuitem>\n");
    $this->print_projectlinks();
    echo("                </TD>\n");
    echo("              </TR>\n");
    echo("            </TABLE>\n");
    echo("          </TD>\n");
    echo("        </TR>\n");
    echo("        <TR>\n");
    echo("          <TD ID=menuborder>\n");
    echo("            <TABLE WIDTH=100% BORDER=0 CELLPADDING=1 CELLSPACEING=1>\n");
    echo("              <TR>\n");
    echo("                <TD ID=menuhead> News </TD>\n");
    echo("              </TR>\n");
    echo("              <TR>\n");
    echo("                <TD ID=menuitem> Feature update </TD>\n");
    echo("              </TR>\n");
    echo("            </TABLE>\n");
    echo("          </TD>\n");
    echo("        </TR>\n");
    echo("      </TABLE>\n");
    echo("    </TD>\n");
    if(empty($this->user->uw_id_data[1]))
      echo("    <TD WIDTH=750 VALIGN=top>\n");
    else
      echo("    <TD WIDTH=".$this->user->uw_id_data[1]." VALIGN=top>\n");
    echo("      <TABLE WIDTH=100% BORDER=0 CELLPADDING=1 CELLSPACING=1>\n");
    echo("        <TR>\n");
    echo("          <TD ID=menuborder ROWSPAN=2 VALIGN=top>\n");
    echo("            <TABLE WIDTH=100% HEIGHT=100% BORDER=0 CELLPADDING=1 CELLSPACING=1>\n");
    echo("              <TR>\n");
    echo("                <TD ID=menuitem>\n");
    echo("                ".$this->content."\n");
    echo("                </TD>\n");
    echo("              </TR>\n");
    echo("            </TABLE>\n");
    echo("          </TD>\n");
    echo("        </TR>\n");
    echo("      </TABLE>\n");
    echo("    </TD>\n");
    echo("  </TR>\n");
    echo("</TABLE>\n");
    if(empty($this->user->uw_id_data[0]))
      echo("<TABLE WIDTH=900 BORDER=0 CELLPADDING=1 CELLSPACEING=1>\n");
    else
      echo("<TABLE WIDTH=".$this->user->uw_id_data[0]." BORDER=0 CELLPADDING=1 CELLSPACEING=1>\n");
    echo("  <TR>\n");
    echo("    <TD ID=menuborder>\n");
    echo("      <TABLE WIDTH=100% BORDER=0 CELLPADDING=1 CELLSPACING=1>\n");
    echo("        <TR>\n");
    $this->print_shortcuts();
    echo("        </TR>\n");
    echo("      </TABLE>\n");
    echo("    </TD>\n");
    echo("  </TR>\n");
    echo("  <TR>\n");
    echo("    <TD ID=black12 ALIGN=right><A HREF=\"http://sourceforge.net/projects/ueberp/\"><B>&Uuml;berP</B><A> was developed by Alexander Meisel\n");
    echo("  </TR>\n");
    echo("</TABLE>\n");
    echo("</BODY>\n");
    echo("</HTML>\n");
  }

  function show()
  {
    $this->show2("");
  }

}
?>
